Attribute VB_Name = "Global"
Option Explicit
Public FSO As Object
Global Const vbQuote = """" ' Constant for Quotation Marks

'Resource Constants - ICONS
Global Const resMDI = 101
Global Const resDoc = 102
Global Const resSource = 103
'Resource Constants - STRINGS
Global Const resApp = 201
Global Const resVersion = 202
Global Const resError = 203
Global Const resAppDone = 204
Global Const resTab = 205

Global Const BlankNum = 5
Global Const TI83Num = 4
Global Const TI83PNum = 3
Global Const TI86Num = 2
Global Const TI8992Num = 1
Global Const IncludeNum = 0

Global Const BlankFile = ""
Global Const TI83Program = ".nolist" & vbNewLine & " #define end .end" & vbNewLine & " #define END .end" & vbNewLine & " #define equ .equ" & vbNewLine & " #define EQU .equ" & vbNewLine & " #include " & vbQuote & "ti83asm.inc" & vbQuote & vbNewLine & " #include " & vbQuote & "tokens.inc" & vbQuote & vbNewLine & ".list" & vbNewLine & ".org 9327h" & vbNewLine & vbNewLine & "  ;YOUR CODE GOES HERE [REMOVE THIS LINE]" & vbNewLine & "  ret" & vbNewLine & vbNewLine & " .end" & vbNewLine & "END"
Global Const TI83PProgram = ";REMEMBER TO USE 'bcall' INSTEAD OF 'call' FOR ROM-CALLS!" & vbNewLine & vbNewLine & ".nolist" & vbNewLine & " #define end .end" & vbNewLine & " #define END .end" & vbNewLine & " #define equ .equ" & vbNewLine & " #define EQU .equ" & vbNewLine & " #include " & vbQuote & "ti83plus.inc" & vbQuote & " ;I ALREADY MODIFIED THIS FOR tasm AND bcall()..." & vbNewLine & ".list" & vbNewLine & ".org 9D95h" & vbNewLine & vbNewLine & "  ;YOUR CODE GOES HERE [REMOVE THIS LINE]" & vbNewLine & "  ret" & vbNewLine & vbNewLine & " .end" & vbNewLine & "END"
Global Const TI86Program = ".nolist" & vbNewLine & " #include " & vbQuote & "asm86.h" & vbQuote & vbNewLine & " #include " & vbQuote & "ti86all.inc" & vbQuote & vbNewLine & ".list" & vbNewLine & ".org _asm_exec_ram" & vbNewLine & vbNewLine & "  ;YOUR CODE GOES HERE [REMOVE THIS LINE]" & vbNewLine & "  ret" & vbNewLine & vbNewLine & " .end" & vbNewLine & "END"
Global Const TI8992Program = " include " & vbQuote & "tios.h" & vbQuote & vbNewLine & " xdef    _main" & vbNewLine & " xdef    _nostub" & vbNewLine & " xdef    _ti89" & vbNewLine & " xdef    _ti92plus" & vbNewLine & vbNewLine & "_main:   ;YOUR CODE GOES HERE [REMOVE THIS LINE]" & vbNewLine & "         rts" & vbNewLine & vbNewLine & "         end"
Global Const IncludeFile = ";;;;;;;;;;;;;;;;;;;" & vbNewLine & "; My Include File ;" & vbNewLine & ";;;;;;;;;;;;;;;;;;;"

Public Declare Function SendMessage Lib "User32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Sub SetWindowPos Lib "User32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)

Public Function LowerCase(vbMixedStr) As String
  LowerCase = StrConv(vbMixedStr, vbLowerCase)
End Function

Public Function UpperCase(vbMixedStr) As String
  UpperCase = StrConv(vbMixedStr, vbUpperCase)
End Function

Public Function RemoveTABs(PREString) As String
  RemoveTABs = Replace(PREString, vbTab, " ")
End Function

Public Function File_NO_EXTension(FName) As String

  Dim Count, X
  For Count = Len(FName) To 1 Step -1
   X = Mid(FName, Count, 1)
   If X = "." Then
    X = Left(FName, Count - 1)
    GoTo ReturnValue
   End If
  Next Count
  X = FName
  
ReturnValue:
  File_NO_EXTension = X

End Function

Public Function File_NO_DIRectory(PathName) As String

  Dim Count, X
  For Count = Len(PathName) - 1 To 1 Step -1
   X = Mid(PathName, Count, 1)
   If X = "\" Then
    X = Mid(PathName, Count + 1)
    GoTo ReturnValue
   End If
  Next Count
  X = PathName

ReturnValue:
  File_NO_DIRectory = X

End Function

'''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''
' Menus                         '
'''''''''''''''''''''''''''''''''

Public Sub NewFile() ' File/New
  frmNew.Show vbModal, frmMDI
End Sub

Public Sub OpenFile() ' File/Open

  On Error GoTo ErrHandler ' CancelError is True.
  With frmMDI.OpenASMDialog
    .FileName = ""
    .DialogTitle = "Open: Source Code" ' WindowTitle OPEN
    .Filter = "All Files|*.*|All Supported Files|*.asm;*.z80;*.68k;*.inc;*.h|Assembly Source Files (*.asm,*.z80,*.68k)|*.asm;*.z80;*.68k|Include Files (*.inc)|*.inc|Header Files (*.h)|*.h" ' Set filters.
    .FilterIndex = 2 ' Specify default filter.
    .Flags = cdlOFNHideReadOnly
    .ShowOpen ' Display the Open dialog box.
  End With
  GoTo DispIt

ErrHandler:
  Exit Sub

DispIt:
  Dim TABs, NewSrc As New frmASM
  NewSrc.WindowState = vbNormal
  NewSrc.Caption = frmMDI.OpenASMDialog.FileName
  NewSrc.CurrentFile = frmMDI.OpenASMDialog.FileName
  NewSrc.Icon = LoadResPicture(resDoc, vbResIcon)
  frmMDI.ActiveFile = frmMDI.OpenASMDialog.FileName
  NewSrc.Show
  NewSrc.RichTextBox1.LoadFile frmMDI.ActiveFile, rtfText
  NewSrc.Caption = frmMDI.OpenASMDialog.FileName
  NewSrc.CurrentEdit = 0
  If InStr(NewSrc.RichTextBox1.Text, Chr(9)) <> 0 Then
    TABs = MsgBox("Would you like [TAB] key instances removed from your source?", vbQuestion + vbYesNo, LoadResString(resTab))
    If TABs = vbYes Then
      NewSrc.RichTextBox1.Text = RemoveTABs(NewSrc.RichTextBox1.Text)
      NewSrc.CurrentEdit = 1
    End If
  End If
  NewSrc.Revert = NewSrc.RichTextBox1.Text

End Sub

Public Sub Contents()
'''DLL NOT NEEDED FOR WINDOWS DIRECTORY'''
'  Public Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long ' This goes in declarations
'  Dim Path As String * 255, ReturnLength, A As String
'  ReturnLength = GetWindowsDirectory(Path, Len(Path))
'  A = Left(Path, ReturnLength)
  Shell Environ("windir") & "\hh.exe " & vbQuote & App.Path & "\aa.chm" & vbQuote, 3
End Sub

Public Sub AboutPRGM() ' Help/About
  frmAbout.Show vbModal, frmMDI
End Sub
